import { KeyValueSuggestion, KeyValueTextDisplay } from "./KeyValueDatatypes";
import { KeyValueType } from "./KeyValueType";
declare type Operator = "<" | ">" | "<=" | ">=" | "!=" | "=";
declare type OpSymbol = "<" | ">" | "≤" | "≥" | "≠" | "=";
interface SlackDateKeyValue {
    operator: OpSymbol | Operator;
    date: Date;
}
interface DateKeyValue extends SlackDateKeyValue {
    operator: Operator;
}
export default class DateKeyValueType extends KeyValueType<DateKeyValue> {
    static mongoSelectorFor(value: DateKeyValue): {
        [x: string]: Date;
    };
    private _dateFormat;
    dateFormat: string;
    private _dateParseFormats;
    dateParseFormats: string[];
    getSuggestions(prefix: string): KeyValueSuggestion[];
    parseString(val: string): DateKeyValue | undefined;
    checkValue(val: any): DateKeyValue | undefined;
    display(value: SlackDateKeyValue): KeyValueTextDisplay;
    editText(value: SlackDateKeyValue): string;
}
export {};
