import { KeyValueEntry } from "./KeyValueEntry";
var KeyValueType = /** @class */ (function () {
    function KeyValueType(id, label, aliases) {
        if (aliases === void 0) { aliases = []; }
        this._id = id;
        this._label = label;
        this._aliases = [id, label].concat(aliases).map(function (a) { return a.toLowerCase(); });
    }
    Object.defineProperty(KeyValueType.prototype, "id", {
        get: function () {
            return this._id;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(KeyValueType.prototype, "label", {
        get: function () {
            return this._label;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(KeyValueType.prototype, "aliases", {
        get: function () {
            return this._aliases;
        },
        enumerable: true,
        configurable: true
    });
    KeyValueType.prototype.findAlias = function (substring) {
        var substringLower = substring.toLowerCase();
        return this.aliases.find(function (a) { return a.includes(substringLower); });
    };
    KeyValueType.prototype.createPartialEntry = function () {
        return new KeyValueEntry(this);
    };
    KeyValueType.prototype.tryCreatePartialEntry = function (key) {
        if (!this.aliases.includes(key.toLowerCase())) {
            return undefined;
        }
        return new KeyValueEntry(this);
    };
    KeyValueType.prototype.tryCreateFullEntry = function (val) {
        var entry = new KeyValueEntry(this);
        if (entry.set(val)) {
            return entry;
        }
        else {
            return undefined;
        }
    };
    KeyValueType.prototype.isEqual = function (entryA, entryB) {
        return entryA.type === entryB.type && entryA.value === entryB.value;
    };
    return KeyValueType;
}());
export { KeyValueType };
