import { NumberDelimiters } from "../helpers/formatting";
import { KeyValueSuggestion, KeyValueTextDisplay } from "./KeyValueDatatypes";
import { KeyValueType } from "./KeyValueType";
import NumberFormat = Intl.NumberFormat;
declare type Operator = "<" | ">" | "<=" | ">=" | "!=" | "=";
declare type OpSymbol = "<" | ">" | "≤" | "≥" | "≠" | "=";
interface SlackNumberKeyValue {
    operator: OpSymbol | Operator;
    number: number;
}
interface NumberKeyValue extends SlackNumberKeyValue {
    operator: Operator;
}
export default class NumberKeyValueType extends KeyValueType<NumberKeyValue> {
    static mongoSelectorFor(value: NumberKeyValue, numberTransform?: (n: number) => number): {
        [x: string]: number;
    };
    private _delimiters;
    private _groupsDelimiterRegex;
    delimiters: NumberDelimiters;
    private _numberFormatter?;
    numberFormatter: NumberFormat | undefined;
    getSuggestions(prefix: string): KeyValueSuggestion[];
    parseString(val: string): NumberKeyValue | undefined;
    checkValue(val: any): NumberKeyValue | undefined;
    display(value: SlackNumberKeyValue): KeyValueTextDisplay;
    editText(value: SlackNumberKeyValue): string;
}
export {};
